/* xnoise-notifications.c generated by valac, the Vala compiler
 * generated from xnoise-notifications.vala, do not modify */

/* xnoise-notifications.vala
 *
 * Copyright (C) 2009  Jörn Magens
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The Xnoise authors hereby grant permission for non-GPL compatible
 *  GStreamer plugins to be used and distributed together with GStreamer
 *  and Xnoise. This permission is above and beyond the permissions granted
 *  by the GPL license by which Xnoise is covered. If you modify this code
 *  you may extend this exception to your version of the code, but you are not
 *  obligated to do so. If you do not wish to do so, delete this exception
 *  statement from your version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author:
 * 	Jörn Magens
 * 	fsistemas
 */

#include <glib.h>
#include <glib-object.h>
#include <xnoise.h>
#include <libnotify/notify.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <config.h>
#include <gtk/gtk.h>


#define XNOISE_TYPE_NOTIFICATIONS (xnoise_notifications_get_type ())
#define XNOISE_NOTIFICATIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), XNOISE_TYPE_NOTIFICATIONS, XnoiseNotifications))
#define XNOISE_NOTIFICATIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), XNOISE_TYPE_NOTIFICATIONS, XnoiseNotificationsClass))
#define XNOISE_IS_NOTIFICATIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), XNOISE_TYPE_NOTIFICATIONS))
#define XNOISE_IS_NOTIFICATIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), XNOISE_TYPE_NOTIFICATIONS))
#define XNOISE_NOTIFICATIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), XNOISE_TYPE_NOTIFICATIONS, XnoiseNotificationsClass))

typedef struct _XnoiseNotifications XnoiseNotifications;
typedef struct _XnoiseNotificationsClass XnoiseNotificationsClass;
typedef struct _XnoiseNotificationsPrivate XnoiseNotificationsPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
#define _xnoise_db_browser_unref0(var) ((var == NULL) ? NULL : (var = (xnoise_db_browser_unref (var), NULL)))
#define _xnoise_track_data_unref0(var) ((var == NULL) ? NULL : (var = (xnoise_track_data_unref (var), NULL)))

struct _XnoiseNotifications {
	GObject parent_instance;
	XnoiseNotificationsPrivate * priv;
};

struct _XnoiseNotificationsClass {
	GObjectClass parent_class;
};

struct _XnoiseNotificationsPrivate {
	XnoiseMain* _xn;
	NotifyNotification* notification;
	guint timeout;
};

struct _Block1Data {
	int _ref_count_;
	XnoiseNotifications * self;
	char* uri;
};


static gpointer xnoise_notifications_parent_class = NULL;
static XnoiseIPluginIface* xnoise_notifications_xnoise_iplugin_parent_iface = NULL;
static GType xnoise_notifications_type_id = 0;

GType xnoise_notifications_get_type (void);
GType xnoise_notifications_register_type (GTypeModule * module);
#define XNOISE_NOTIFICATIONS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), XNOISE_TYPE_NOTIFICATIONS, XnoiseNotificationsPrivate))
enum  {
	XNOISE_NOTIFICATIONS_DUMMY_PROPERTY,
	XNOISE_NOTIFICATIONS_XN,
	XNOISE_NOTIFICATIONS_NAME
};
#define XNOISE_NOTIFICATIONS_IMAGE_SIZE 64
static void xnoise_notifications_on_uri_changed (XnoiseNotifications* self, const char* uri);
static void _xnoise_notifications_on_uri_changed_xnoise_global_info_uri_changed (XnoiseGlobalInfo* _sender, const char* uri, gpointer self);
static void xnoise_notifications_on_restart (XnoiseNotifications* self);
static void _xnoise_notifications_on_restart_xnoise_global_info_sign_restart_song (XnoiseGlobalInfo* _sender, gpointer self);
static gboolean xnoise_notifications_real_init (XnoiseIPlugin* base);
static gboolean _lambda1_ (XnoiseNotifications* self);
static gboolean __lambda1__gsource_func (gpointer self);
static void xnoise_notifications_show_notification (XnoiseNotifications* self, const char* newuri);
static gboolean _lambda0_ (Block1Data* _data1_);
static gboolean __lambda0__gsource_func (gpointer self);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (Block1Data* _data1_);
void xnoise_notifications_show (XnoiseNotifications* self);
static void xnoise_notifications_cleanup (XnoiseNotifications* self);
static GtkWidget* xnoise_notifications_real_get_settings_widget (XnoiseIPlugin* base);
static GtkWidget* xnoise_notifications_real_get_singleline_settings_widget (XnoiseIPlugin* base);
static gboolean xnoise_notifications_real_has_settings_widget (XnoiseIPlugin* base);
static gboolean xnoise_notifications_real_has_singleline_settings_widget (XnoiseIPlugin* base);
XnoiseNotifications* xnoise_notifications_new (void);
XnoiseNotifications* xnoise_notifications_construct (GType object_type);
static GObject * xnoise_notifications_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void xnoise_notifications_finalize (GObject* obj);
static void xnoise_notifications_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void xnoise_notifications_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static int _vala_strcmp0 (const char * str1, const char * str2);



static void _xnoise_notifications_on_uri_changed_xnoise_global_info_uri_changed (XnoiseGlobalInfo* _sender, const char* uri, gpointer self) {
	xnoise_notifications_on_uri_changed (self, uri);
}


static void _xnoise_notifications_on_restart_xnoise_global_info_sign_restart_song (XnoiseGlobalInfo* _sender, gpointer self) {
	xnoise_notifications_on_restart (self);
}


static gboolean xnoise_notifications_real_init (XnoiseIPlugin* base) {
	XnoiseNotifications * self;
	gboolean result = FALSE;
	self = (XnoiseNotifications*) base;
	if (!notify_init ("Xnoise media player")) {
		g_print ("libnotify initialization failed\n");
		result = FALSE;
		return result;
	}
	g_signal_connect_object (xnoise_global, "uri-changed", (GCallback) _xnoise_notifications_on_uri_changed_xnoise_global_info_uri_changed, self, 0);
	g_signal_connect_object (xnoise_global, "sign-restart-song", (GCallback) _xnoise_notifications_on_restart_xnoise_global_info_sign_restart_song, self, 0);
	result = TRUE;
	return result;
}


static gboolean _lambda1_ (XnoiseNotifications* self) {
	gboolean result = FALSE;
	xnoise_notifications_on_uri_changed (self, xnoise_global_info_get_current_uri (xnoise_global));
	result = FALSE;
	return result;
}


static gboolean __lambda1__gsource_func (gpointer self) {
	gboolean result;
	result = _lambda1_ (self);
	return result;
}


static void xnoise_notifications_on_restart (XnoiseNotifications* self) {
	g_return_if_fail (self != NULL);
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, __lambda1__gsource_func, g_object_ref (self), g_object_unref);
}


static gboolean _lambda0_ (Block1Data* _data1_) {
	XnoiseNotifications * self;
	gboolean result = FALSE;
	self = _data1_->self;
	xnoise_notifications_show_notification (self, _data1_->uri);
	result = FALSE;
	return result;
}


static gboolean __lambda0__gsource_func (gpointer self) {
	gboolean result;
	result = _lambda0_ (self);
	return result;
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	++_data1_->_ref_count_;
	return _data1_;
}


static void block1_data_unref (Block1Data* _data1_) {
	if ((--_data1_->_ref_count_) == 0) {
		_g_object_unref0 (_data1_->self);
		_g_free0 (_data1_->uri);
		g_slice_free (Block1Data, _data1_);
	}
}


static void xnoise_notifications_on_uri_changed (XnoiseNotifications* self, const char* uri) {
	GError * _inner_error_;
	Block1Data* _data1_;
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_data1_->uri = g_strdup (uri);
	if (self->priv->timeout != 0) {
		g_source_remove (self->priv->timeout);
		self->priv->timeout = (guint) 0;
	}
	if (_vala_strcmp0 (_data1_->uri, "") == 0) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = _data1_->uri == NULL;
	}
	if (_tmp0_) {
		{
			if (self->priv->notification != NULL) {
				notify_notification_clear_hints (self->priv->notification);
				notify_notification_close (self->priv->notification, &_inner_error_);
				if (_inner_error_ != NULL) {
					goto __catch0_g_error;
				}
			}
			block1_data_unref (_data1_);
			return;
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
				g_print ("%s\n", e->message);
				_g_error_free0 (e);
			}
		}
		__finally0:
		if (_inner_error_ != NULL) {
			block1_data_unref (_data1_);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	self->priv->timeout = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, __lambda0__gsource_func, block1_data_ref (_data1_), block1_data_unref);
	block1_data_unref (_data1_);
}


static void xnoise_notifications_show_notification (XnoiseNotifications* self, const char* newuri) {
	GError * _inner_error_;
	XnoiseDbBrowser* dbb;
	char* uri;
	char* image_path;
	char* album;
	char* artist;
	char* title;
	GdkPixbuf* image_pixb;
	char* basename;
	GFile* file;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	char* _tmp17_;
	char* _tmp18_;
	char* summary;
	char* _tmp24_;
	char* _tmp23_;
	char* _tmp22_;
	char* _tmp21_;
	char* _tmp20_;
	char* _tmp19_;
	char* _tmp25_;
	char* body;
	g_return_if_fail (self != NULL);
	g_return_if_fail (newuri != NULL);
	_inner_error_ = NULL;
	dbb = NULL;
	{
		XnoiseDbBrowser* _tmp0_;
		XnoiseDbBrowser* _tmp1_;
		_tmp0_ = xnoise_db_browser_new (&_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch1_g_error;
		}
		dbb = (_tmp1_ = _tmp0_, _xnoise_db_browser_unref0 (dbb), _tmp1_);
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_print ("%s\n", e->message);
			_g_error_free0 (e);
			_xnoise_db_browser_unref0 (dbb);
			return;
		}
	}
	__finally1:
	if (_inner_error_ != NULL) {
		_xnoise_db_browser_unref0 (dbb);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	uri = g_strdup (newuri);
	image_path = NULL;
	album = NULL;
	artist = NULL;
	title = NULL;
	image_pixb = NULL;
	basename = NULL;
	file = g_file_new_for_uri (newuri);
	if (!xnoise_gst_player_get_is_stream (xnoise_iplugin_get_xn ((XnoiseIPlugin*) self)->gPl)) {
		char* _tmp2_;
		basename = (_tmp2_ = g_file_get_basename (file), _g_free0 (basename), _tmp2_);
	}
	if (xnoise_global_info_get_current_artist (xnoise_global) != NULL) {
		char* _tmp3_;
		artist = (_tmp3_ = xnoise_remove_linebreaks (xnoise_global_info_get_current_artist (xnoise_global)), _g_free0 (artist), _tmp3_);
	} else {
		char* _tmp4_;
		artist = (_tmp4_ = g_strdup ("unknown artist"), _g_free0 (artist), _tmp4_);
	}
	if (xnoise_global_info_get_current_title (xnoise_global) != NULL) {
		char* _tmp5_;
		title = (_tmp5_ = xnoise_remove_linebreaks (xnoise_global_info_get_current_title (xnoise_global)), _g_free0 (title), _tmp5_);
	} else {
		char* _tmp6_;
		title = (_tmp6_ = g_strdup ("unknown title"), _g_free0 (title), _tmp6_);
	}
	if (xnoise_global_info_get_current_album (xnoise_global) != NULL) {
		char* _tmp7_;
		album = (_tmp7_ = xnoise_remove_linebreaks (xnoise_global_info_get_current_album (xnoise_global)), _g_free0 (album), _tmp7_);
	} else {
		char* _tmp8_;
		album = (_tmp8_ = g_strdup ("unknown album"), _g_free0 (album), _tmp8_);
	}
	if (_vala_strcmp0 (title, "unknown title") == 0) {
		_tmp10_ = _vala_strcmp0 (artist, "unknown artist") == 0;
	} else {
		_tmp10_ = FALSE;
	}
	if (_tmp10_) {
		_tmp9_ = _vala_strcmp0 (album, "unknown album") == 0;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		XnoiseTrackData* td;
		XnoiseTrackData* _tmp13_;
		gboolean _tmp12_;
		XnoiseTrackData* _tmp11_ = NULL;
		td = NULL;
		if ((_tmp12_ = xnoise_db_browser_get_trackdata_for_uri (dbb, newuri, &_tmp11_), td = (_tmp13_ = _tmp11_, _xnoise_track_data_unref0 (td), _tmp13_), _tmp12_)) {
			char* _tmp14_;
			char* _tmp15_;
			char* _tmp16_;
			artist = (_tmp14_ = g_strdup (td->Artist), _g_free0 (artist), _tmp14_);
			album = (_tmp15_ = g_strdup (td->Album), _g_free0 (album), _tmp15_);
			title = (_tmp16_ = g_strdup (td->Title), _g_free0 (title), _tmp16_);
		}
		_xnoise_track_data_unref0 (td);
	}
	xnoise_get_image_path_for_media_uri (uri, &image_path);
	summary = (_tmp18_ = g_strdup (title), _g_free0 (summary), _tmp18_);
	body = (_tmp25_ = g_strconcat (_tmp24_ = g_strconcat (_tmp23_ = g_strconcat (_tmp22_ = g_strconcat (_tmp21_ = g_strconcat (_tmp20_ = g_strconcat (_tmp19_ = g_strconcat (_ ("by"), " <b>", NULL), artist, NULL), "</b> \n", NULL), _ ("on"), NULL), " <b>", NULL), album, NULL), "</b>", NULL), _g_free0 (_tmp24_), _g_free0 (_tmp23_), _g_free0 (_tmp22_), _g_free0 (_tmp21_), _g_free0 (_tmp20_), _g_free0 (_tmp19_), _tmp25_);
	if (self->priv->notification == NULL) {
		NotifyNotification* _tmp26_;
		self->priv->notification = (_tmp26_ = notify_notification_new (summary, body, NULL, NULL), _g_object_unref0 (self->priv->notification), _tmp26_);
	} else {
		notify_notification_clear_hints (self->priv->notification);
		notify_notification_update (self->priv->notification, summary, body, "");
	}
	if (image_path != NULL) {
		{
			GdkPixbuf* _tmp27_;
			GdkPixbuf* _tmp28_;
			_tmp27_ = gdk_pixbuf_new_from_file (image_path, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch2_g_error;
			}
			image_pixb = (_tmp28_ = _tmp27_, _g_object_unref0 (image_pixb), _tmp28_);
			if (image_pixb != NULL) {
				GdkPixbuf* _tmp29_;
				image_pixb = (_tmp29_ = gdk_pixbuf_scale_simple (image_pixb, XNOISE_NOTIFICATIONS_IMAGE_SIZE, XNOISE_NOTIFICATIONS_IMAGE_SIZE, GDK_INTERP_BILINEAR), _g_object_unref0 (image_pixb), _tmp29_);
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
				g_print ("%s\n", e->message);
				_g_error_free0 (e);
			}
		}
		__finally2:
		if (_inner_error_ != NULL) {
			_xnoise_db_browser_unref0 (dbb);
			_g_free0 (uri);
			_g_free0 (image_path);
			_g_free0 (album);
			_g_free0 (artist);
			_g_free0 (title);
			_g_object_unref0 (image_pixb);
			_g_free0 (basename);
			_g_object_unref0 (file);
			_g_free0 (summary);
			_g_free0 (body);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	} else {
		{
			GdkPixbuf* _tmp30_;
			GdkPixbuf* _tmp31_;
			_tmp30_ = gdk_pixbuf_new_from_file (UIDIR "xnoise_48x48.png", &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch3_g_error;
			}
			image_pixb = (_tmp31_ = _tmp30_, _g_object_unref0 (image_pixb), _tmp31_);
		}
		goto __finally3;
		__catch3_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
				g_print ("%s\n", e->message);
				_g_error_free0 (e);
			}
		}
		__finally3:
		if (_inner_error_ != NULL) {
			_xnoise_db_browser_unref0 (dbb);
			_g_free0 (uri);
			_g_free0 (image_path);
			_g_free0 (album);
			_g_free0 (artist);
			_g_free0 (title);
			_g_object_unref0 (image_pixb);
			_g_free0 (basename);
			_g_object_unref0 (file);
			_g_free0 (summary);
			_g_free0 (body);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	if (image_pixb != NULL) {
		notify_notification_set_icon_from_pixbuf (self->priv->notification, image_pixb);
	}
	notify_notification_set_urgency (self->priv->notification, NOTIFY_URGENCY_NORMAL);
	notify_notification_set_timeout (self->priv->notification, 2000);
	xnoise_notifications_show (self);
	_xnoise_db_browser_unref0 (dbb);
	_g_free0 (uri);
	_g_free0 (image_path);
	_g_free0 (album);
	_g_free0 (artist);
	_g_free0 (title);
	_g_object_unref0 (image_pixb);
	_g_free0 (basename);
	_g_object_unref0 (file);
	_g_free0 (summary);
	_g_free0 (body);
}


void xnoise_notifications_show (XnoiseNotifications* self) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	{
		notify_notification_show (self->priv->notification, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch4_g_error;
		}
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			g_print ("%s\n", e->message);
			_g_error_free0 (e);
		}
	}
	__finally4:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void xnoise_notifications_cleanup (XnoiseNotifications* self) {
	GError * _inner_error_;
	g_return_if_fail (self != NULL);
	_inner_error_ = NULL;
	if (self->priv->notification != NULL) {
		{
			NotifyNotification* _tmp0_;
			notify_notification_close (self->priv->notification, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch5_g_error;
			}
			self->priv->notification = (_tmp0_ = NULL, _g_object_unref0 (self->priv->notification), _tmp0_);
		}
		goto __finally5;
		__catch5_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
				g_print ("%s\n", e->message);
				_g_error_free0 (e);
			}
		}
		__finally5:
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static GtkWidget* xnoise_notifications_real_get_settings_widget (XnoiseIPlugin* base) {
	XnoiseNotifications * self;
	GtkWidget* result = NULL;
	self = (XnoiseNotifications*) base;
	result = NULL;
	return result;
}


static GtkWidget* xnoise_notifications_real_get_singleline_settings_widget (XnoiseIPlugin* base) {
	XnoiseNotifications * self;
	GtkWidget* result = NULL;
	self = (XnoiseNotifications*) base;
	result = NULL;
	return result;
}


static gboolean xnoise_notifications_real_has_settings_widget (XnoiseIPlugin* base) {
	XnoiseNotifications * self;
	gboolean result = FALSE;
	self = (XnoiseNotifications*) base;
	result = FALSE;
	return result;
}


static gboolean xnoise_notifications_real_has_singleline_settings_widget (XnoiseIPlugin* base) {
	XnoiseNotifications * self;
	gboolean result = FALSE;
	self = (XnoiseNotifications*) base;
	result = FALSE;
	return result;
}


XnoiseNotifications* xnoise_notifications_construct (GType object_type) {
	XnoiseNotifications * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


XnoiseNotifications* xnoise_notifications_new (void) {
	return xnoise_notifications_construct (XNOISE_TYPE_NOTIFICATIONS);
}


static XnoiseMain* xnoise_notifications_real_get_xn (XnoiseIPlugin* base) {
	XnoiseMain* result;
	XnoiseNotifications* self;
	self = (XnoiseNotifications*) base;
	result = self->priv->_xn;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void xnoise_notifications_real_set_xn (XnoiseIPlugin* base, XnoiseMain* value) {
	XnoiseNotifications* self;
	XnoiseMain* _tmp0_;
	self = (XnoiseNotifications*) base;
	self->priv->_xn = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_xn), _tmp0_);
	g_object_notify ((GObject *) self, "xn");
}


static const char* xnoise_notifications_real_get_name (XnoiseIPlugin* base) {
	const char* result;
	XnoiseNotifications* self;
	self = (XnoiseNotifications*) base;
	result = "notifications";
	return result;
}


static GObject * xnoise_notifications_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	XnoiseNotifications * self;
	parent_class = G_OBJECT_CLASS (xnoise_notifications_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = XNOISE_NOTIFICATIONS (obj);
	{
		self->priv->timeout = (guint) 0;
	}
	return obj;
}


static void xnoise_notifications_class_init (XnoiseNotificationsClass * klass) {
	xnoise_notifications_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (XnoiseNotificationsPrivate));
	G_OBJECT_CLASS (klass)->get_property = xnoise_notifications_get_property;
	G_OBJECT_CLASS (klass)->set_property = xnoise_notifications_set_property;
	G_OBJECT_CLASS (klass)->constructor = xnoise_notifications_constructor;
	G_OBJECT_CLASS (klass)->finalize = xnoise_notifications_finalize;
	g_object_class_override_property (G_OBJECT_CLASS (klass), XNOISE_NOTIFICATIONS_XN, "xn");
	g_object_class_override_property (G_OBJECT_CLASS (klass), XNOISE_NOTIFICATIONS_NAME, "name");
}


static void xnoise_notifications_xnoise_iplugin_interface_init (XnoiseIPluginIface * iface) {
	xnoise_notifications_xnoise_iplugin_parent_iface = g_type_interface_peek_parent (iface);
	iface->init = xnoise_notifications_real_init;
	iface->get_settings_widget = xnoise_notifications_real_get_settings_widget;
	iface->get_singleline_settings_widget = xnoise_notifications_real_get_singleline_settings_widget;
	iface->has_settings_widget = xnoise_notifications_real_has_settings_widget;
	iface->has_singleline_settings_widget = xnoise_notifications_real_has_singleline_settings_widget;
	iface->get_xn = xnoise_notifications_real_get_xn;
	iface->set_xn = xnoise_notifications_real_set_xn;
	iface->get_name = xnoise_notifications_real_get_name;
}


static void xnoise_notifications_instance_init (XnoiseNotifications * self) {
	self->priv = XNOISE_NOTIFICATIONS_GET_PRIVATE (self);
	self->priv->notification = NULL;
}


static void xnoise_notifications_finalize (GObject* obj) {
	XnoiseNotifications * self;
	self = XNOISE_NOTIFICATIONS (obj);
	{
		xnoise_notifications_cleanup (self);
	}
	_g_object_unref0 (self->priv->_xn);
	_g_object_unref0 (self->priv->notification);
	G_OBJECT_CLASS (xnoise_notifications_parent_class)->finalize (obj);
}


GType xnoise_notifications_get_type (void) {
	return xnoise_notifications_type_id;
}


GType xnoise_notifications_register_type (GTypeModule * module) {
	static const GTypeInfo g_define_type_info = { sizeof (XnoiseNotificationsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) xnoise_notifications_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (XnoiseNotifications), 0, (GInstanceInitFunc) xnoise_notifications_instance_init, NULL };
	static const GInterfaceInfo xnoise_iplugin_info = { (GInterfaceInitFunc) xnoise_notifications_xnoise_iplugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	xnoise_notifications_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "XnoiseNotifications", &g_define_type_info, 0);
	g_type_module_add_interface (module, xnoise_notifications_type_id, XNOISE_TYPE_IPLUGIN, &xnoise_iplugin_info);
	return xnoise_notifications_type_id;
}


static void xnoise_notifications_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	XnoiseNotifications * self;
	self = XNOISE_NOTIFICATIONS (object);
	switch (property_id) {
		case XNOISE_NOTIFICATIONS_XN:
		g_value_set_object (value, xnoise_iplugin_get_xn ((XnoiseIPlugin*) self));
		break;
		case XNOISE_NOTIFICATIONS_NAME:
		g_value_set_string (value, xnoise_iplugin_get_name ((XnoiseIPlugin*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void xnoise_notifications_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	XnoiseNotifications * self;
	self = XNOISE_NOTIFICATIONS (object);
	switch (property_id) {
		case XNOISE_NOTIFICATIONS_XN:
		xnoise_iplugin_set_xn ((XnoiseIPlugin*) self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




